package org.zeroturnaround.javarebel.integration.support;

import org.zeroturnaround.bundled.javassist.ByteArrayClassPath;
import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.LoaderClassPath;
import org.zeroturnaround.javarebel.ClassBytecodeProcessor;
import org.zeroturnaround.javarebel.LoggerFactory;

public abstract class JavassistClassBytecodeProcessor implements ClassBytecodeProcessor {
  public final byte[] process(ClassLoader cl, String classname, byte[] bytecode) {
    try {
      classname = classname.replace('/', '.');
      ClassPool cp = new ClassPool();
      cp.insertClassPath(new ByteArrayClassPath(classname, bytecode));
      cp.appendSystemPath();
      cp.insertClassPath(new LoaderClassPath(cl));
      CtClass cc = cp.get(classname);
      cc.defrost();
      process(cp, cl, cc);
      return cc.toBytecode();
    } 
    catch (Throwable e) {
      LoggerFactory.getInstance().errorEcho(e);
      throw new RuntimeException(e);
    }
  }
  
  public abstract void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception;
  
}
